/** Promise Pool */
export default class PromisePool<EveryItemResult extends any> {
	/** How many tasks to run at once. */
	concurrency: number
	/** How many tasks are currently running. */
	running: number
	/** How many tasks have been started. */
	started: number
	/** For upcoming tasks, they have a function (a promise resolver) inserted into the queue which starts the task when called. */
	protected readonly queue: Array<Function>
	/** Instantiate the PromisePool with the desired concurrency. */
	constructor(concurrency?: number)
	/** Add a task to the pool. */
	open<AnyItemResult extends EveryItemResult>(
		task: () => Promise<AnyItemResult> | AnyItemResult
	): Promise<AnyItemResult>
}
//# sourceMappingURL=index.d.ts.map
